' --------------------------------------------------------------------------------------
'
' RobStanze.VB                                                    Ulrich Mller 22.06.02
'                                                                 PCS1700   VB.NET Final
' Beschicken der Stanzmascine mit Transportband 51 663
' durch Industry Robot (Knickarm- oder Sulenrobot) im Simultanbetrieb
' frmMain      : MainThread Steuerung des Betriebsablaufs, Bedieneroberflche
' RobThread    : Thread     Beschickung durch Industry Robot
' StanzThread  : Thread     Betrieb der Stanzmaschine
' umFish30.DLL : Thread     Zugriff auf das interface, durch MultiMediaTimer gesteuert
'
' Modell : 2 x Intelligent Interface an COM1 und COM2
'          alternativ : Intelligent Interface mit Extension Module, in diesem Fall
'          ist nur eine FishFace Instanz erforderlich.
'          Die Modellkonstanten mssen dann entsprechend gendert werden
' Interface Belegung : ftS / COM1 Stanze, ftR / COM2 Industry Robot
' Zum Aufbau der Stanze siehe Stanze.HTM, Schaltung siehe Modellkonstanten.
' Der Industry Robot (Sulen-/Knickarm Robot) mu nach handbuch aufgebaut sein.
' 
' Der Bewegungsablauf des Robots wurde nur angedeutet und sollte nach Gegebenheiten 
' und eigenen Vorstellungen ausgebaut werden. Dabei sollte bercksichtigt werden,
' dass alle vier Motoren simultan laufen knnen. Bei einem Teilschritt knnen also
' mehrere ftR.SetMotor einem ftR.WaitForMotors vorangehen (siehe auch Home)
'
' -------------------------------------------------------------------------------------

Imports System.Threading
Imports FishFa30

Public Class frmMain
    Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

    Public Sub New()
        MyBase.New()

        ' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
        InitializeComponent()

        ' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

    End Sub

    ' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    ' Fr Windows Form-Designer erforderlich
    Private components As System.ComponentModel.IContainer

    'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
    'Sie kann mit dem Windows Form-Designer modifiziert werden.
    'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
    Friend WithEvents cmdAction As System.Windows.Forms.Button
    Friend WithEvents cmdEnde As System.Windows.Forms.Button
    Friend WithEvents lblStanze As System.Windows.Forms.Label
    Friend WithEvents lblRob As System.Windows.Forms.Label
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.cmdAction = New System.Windows.Forms.Button()
        Me.cmdEnde = New System.Windows.Forms.Button()
        Me.lblStanze = New System.Windows.Forms.Label()
        Me.lblRob = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'cmdAction
        '
        Me.cmdAction.Font = New System.Drawing.Font("Tahoma", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdAction.Location = New System.Drawing.Point(264, 168)
        Me.cmdAction.Name = "cmdAction"
        Me.cmdAction.Size = New System.Drawing.Size(112, 32)
        Me.cmdAction.TabIndex = 0
        Me.cmdAction.Text = "&START"
        '
        'cmdEnde
        '
        Me.cmdEnde.Font = New System.Drawing.Font("Tahoma", 9.75!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.cmdEnde.Location = New System.Drawing.Point(264, 128)
        Me.cmdEnde.Name = "cmdEnde"
        Me.cmdEnde.Size = New System.Drawing.Size(112, 32)
        Me.cmdEnde.TabIndex = 1
        Me.cmdEnde.Text = "&ENDE"
        '
        'lblStanze
        '
        Me.lblStanze.Font = New System.Drawing.Font("Tahoma", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblStanze.Location = New System.Drawing.Point(24, 16)
        Me.lblStanze.Name = "lblStanze"
        Me.lblStanze.Size = New System.Drawing.Size(352, 24)
        Me.lblStanze.TabIndex = 3
        Me.lblStanze.Text = "Stanze"
        Me.lblStanze.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'lblRob
        '
        Me.lblRob.Font = New System.Drawing.Font("Tahoma", 12.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.lblRob.Location = New System.Drawing.Point(24, 56)
        Me.lblRob.Name = "lblRob"
        Me.lblRob.Size = New System.Drawing.Size(352, 24)
        Me.lblRob.TabIndex = 4
        Me.lblRob.Text = "Robot"
        Me.lblRob.TextAlign = System.Drawing.ContentAlignment.MiddleCenter
        '
        'frmMain
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(400, 229)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.lblRob, Me.lblStanze, Me.cmdEnde, Me.cmdAction})
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.MaximizeBox = False
        Me.Name = "frmMain"
        Me.Text = "RobStanze : Rob fttert Stanzmaschine 51 663"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' --- FishFace Klassen-Instanz ---------------------------------------------------

    Dim ftR As New FishFace(False, False, 0)
    Dim ftS As New FishFace(False, False, 0)
    Dim robThread As Thread
    Dim stanzThread As Thread
    Dim robReady As New AutoResetEvent(False)
    Dim stanzeReady As New AutoResetEvent(False)
    
    ' --- Interface-Belegung --------------------------------------------------------

    Const mBand = 1, cbVor = 1, cbRuck = 2
    Const ePhotoV = 1, ePhotoS = 2, mLampen = 3
    Const mStanze = 2, eOben = 3, eUnten = 4, csAb = 1, csAuf = 2
    Const mSaule = 1, mArmV = 3, mArmH = 2, mGreifer = 4
    Const ftiEin = 1, ftiAus = 0, ftiLinks = 1, ftiRechts = 2

    ' --- cmdEnde_Click : Beenden des Modellbetriebs bei Button = HALT ---------------
    '     bei Button = ENDE Beenden des Programms

    Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
        If cmdEnde.Text = "&HALT" Then
            ' --- Beenden des Stanzbetriebs -----------------------------
            lblStanze.Text = "Beenden wird eingeleitet"
            ftR.NotHalt = True          ' --- Schleifenende
            stanzeReady.Set()           ' --- StanzPhase schalten
            robThread.Join()            ' --- Warten auf Ende RobThread
            ftS.NotHalt = True
            robReady.Set()
            stanzThread.Join()          ' --- Warten auf Ende StanzThread

            ftR.CloseInterface()        ' --- Interface abschalten
            ftS.CloseInterface()

            cmdAction.Enabled = True    ' --- Buttons sortieren
            cmdEnde.Text = "&ENDE"
        Else
            ' --- Programmende -------------------------------------------
            Me.Close()
        End If
    End Sub

    ' --- frmMain_Closing : Schlieen der Form ablehnen, wenn das Modell noch luft ----

    Private Sub frmMain_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
        If cmdEnde.Text = "&HALT" Then e.Cancel = True
    End Sub

    ' --- cmdAction_Click : Starten des Stanzbetriebs ------------------------

    Private Sub cmdAction_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdAction.Click
        Try
            ftR.OpenInterface(Port.COM2, False)   ' --- Verbindung zum Interface COM2
            '                                           ohne DoEvents
            ftS.OpenInterface(Port.COM1, False)

            cmdAction.Enabled = False             ' --- Buttons sortieren
            cmdEnde.Text = "&HALT"
            lblStanze.Text = "Stanze luft"
            lblRob.Text = "Robot luft"
            cmdEnde.Focus()

            ' --- Threads instanzieren, starten -------------------------------------

            robThread = New Thread(AddressOf robExecute)
            stanzThread = New Thread(AddressOf stanzExecute)

            robThread.Start()
            stanzThread.Start()

        Catch eft As FishFaceException
            lblRob.Text = eft.Message
            Return
        End Try
    End Sub

    ' --- robExecute : Nutzroutine des RobThread -------------------------------

    Private Sub robExecute()
        ' --- Home ----------------------------------------------------
        ftR.SetMotor(mSaule, ftiLinks, 15, 999)
        ftR.SetMotor(mArmV, ftiLinks, 15, 999)
        ftR.SetMotor(mArmH, ftiLinks, 15, 999)
        ftR.SetMotor(mGreifer, ftiLinks, 15, 999)
        ftR.WaitForMotors(0, mSaule, mArmV, mArmH, mGreifer)
        ftR.SetMotor(mSaule, ftiRechts, 15, 10)
        ftR.WaitForMotors(0, mSaule)
        Do
            ' --- Greifen --------------------------------------------
            lblRob.Text = "Greifen"
            ftR.SetMotor(mGreifer, ftiRechts, 15, 10)
            ftR.WaitForMotors(0, mGreifer)

            ' --- Zur Ablage -----------------------------------------
            lblRob.Text = "Zur Ablage"
            ftR.SetMotor(mSaule, ftiRechts, 15, 100)
            ftR.WaitForMotors(0, mSaule)

            ' --- Ablegen / Hoch -------------------------------------
            stanzeReady.WaitOne()
            lblRob.Text = "Ablegen"
            ftR.SetMotor(mGreifer, ftiLinks, 15, 999)
            ftR.WaitForMotors(0, mGreifer)
            robReady.Set()

            ' --- Zum Magazin ---------------------------------------
            lblRob.Text = "Zum Magazin"
            ftR.SetMotor(mSaule, ftiLinks, 15, 100)
            ftR.WaitForMotors(0, mSaule)
        Loop While Not ftR.Finish()
        lblStanze.Text = "Stanze steht"
    End Sub

    ' --- stanzExecute : Nutzroutine StanzThread -----------------------------------

    Private Sub stanzExecute()
        ftS.ClearMotors()
        ftS.SetMotor(mStanze, csAuf)
        ftS.WaitForInput(eOben)
        ftS.SetMotor(mStanze, ftiAus)
        ftS.SetMotor(mLampen, ftiEin)
        Do
            ' --- Wartet auf Robot -------------------------------------
            lblStanze.Text = "Wartet"
            stanzeReady.Set()
            robReady.WaitOne()
            ftS.WaitForLow(ePhotoV)   ' --- Test, wenn Robot nicht liefert
            ftS.Pause(1234)           '     mit Hand nachreichen

            ' --- Zur Stanze -------------------------------------------
            lblStanze.Text = "Zur Stanze"
            ftS.SetMotor(mBand, cbVor)
            ftS.WaitForLow(ePhotoS)
            ftS.SetMotor(mBand, ftiAus)

            ' --- Stanzen ----------------------------------------------
            lblStanze.Text = "Stanzen"
            ftS.SetMotor(mStanze, csAb)
            ftS.WaitForInput(eUnten)
            ftS.SetMotor(mStanze, ftiAus)
            ftS.Pause(1000)
            ftS.SetMotor(mStanze, csAuf)
            ftS.WaitForInput(eOben)
            ftS.SetMotor(mStanze, ftiAus)

            ' --- Zurck ----------------------------------------------
            lblStanze.Text = "Zurck"
            ftS.SetMotor(mBand, cbRuck)
            ftS.WaitForInput(ePhotoV, False)
            ftS.Pause(300)
            ftS.SetMotor(mBand, ftiAus)
        Loop While Not ftS.Finish()
        lblStanze.Text = "Stanze steht"
    End Sub

End Class
